#include <ESP8266WiFi.h>
#include "Mail.h"
#include <Ticker.h>
#include <Wire.h>

#define NDEBUG

const char* ssid= "Имя_WiFi_сети";
const char* password = "пароль_WiFi_сети";

const char* const smtpHost[] = {"smtp.mail.ru","smtp.yandex.ru"};   //smtp серверы первой и второй отправляющей почты
const uint16_t smtpPort = 465;     
const char* const smtpUser[] = { "почтовый_ящик_откуда_присылать1","почтовый_ящик_откуда_присылать2"};// почтовые ящики с которых будет отправка письма от есп
const char* const smtpPass[] = { "пароль_от_почтового_ящика_откуда_присылать1","пароль_от_почтового_ящика_откуда_присылать2"};
const char* const mailTo[] = {"почтовый_ящик_куда_присылать_от_первой_почты","почтовый_ящик_куда_присылать_от_второй_почты"};// на какую почту отправить с почтовых ящиков
const char* const mailSubject = "Alarm!!!"; // Тема письма

uint8_t  res_reason;

volatile uint8_t  blink_loop = 0;
volatile uint8_t  blink_mode;
Ticker blinker;

//=======================================================================
void timerIsr()
{
   if(  blink_mode & 1<<(blink_loop&0x07) ) digitalWrite(BUILTIN_LED, LOW); 
   else  digitalWrite(BUILTIN_LED, HIGH);
   blink_loop++;    
}
//=======================================================================
//                               Setup
//=======================================================================

void setup() {
  res_reason=ESP.getResetInfoPtr()->reason;
 
  pinMode(BUILTIN_LED, OUTPUT);
  blink_mode = 0B00001111; //Мигание по 0.5 сек
  blinker.attach(0.125, timerIsr); //Initialize Ticker every 0.125s

#ifndef NDEBUG
  Serial.begin(115200);
  Serial.setTimeout(2000);
  while(!Serial) { }  // Wait for serial to initialize.
  Serial.println(F("Starting..."));
  Serial.print(F("Connecting to \""));
  Serial.print(ssid);
  Serial.println('"');
#endif

  int try_connect = 0;
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) 
        {
         // Check to see if
         if (WiFi.status() == WL_CONNECT_FAILED)
            {
#ifndef NDEBUG               
             Serial.println(F("Failed to connect to WiFi. Please verify credentials: "));
#endif             
             delay(10000);
            }
         delay(500);
#ifndef NDEBUG         
         Serial.print(".");
#endif
         ++try_connect;
         if (try_connect > 20)
            {
#ifndef NDEBUG              
             Serial.println(F("Failed to connect to WiFi. Restarting"));
#endif
             delay(5000);
             ESP.restart();
            }
        }

#ifndef NDEBUG
  Serial.print(' ');
  Serial.println(WiFi.localIP());
  Serial.print(F("RSSI: "));
  Serial.print(WiFi.RSSI());
  Serial.println(F("dBm"));
#endif  
}
//=======================================================================
//                               Loop
//=======================================================================
void loop()
{
 int8_t fail_sent = 0; 
 delay(1000);
 WiFiClient client; 
 delay(2000);
     for (int8_t i = 0; i < 2; ++i)
         {
          if (sendMail(smtpHost[i], smtpPort, smtpUser[i], smtpPass[i], mailTo[i], mailSubject, F("Сработал датчик протечки\r\nСистема оповещения беспроводных датчиков"))) 
             {
#ifndef NDEBUG              
              Serial.print(F("Mail sended through "));
              Serial.println(smtpHost[i]);
#endif              
             } else {
                     ++fail_sent;
#ifndef NDEBUG              
                     Serial.print(F("Error sending mail through "));
                     Serial.println(smtpHost[i]);
#endif                     
                     }
          delay(500);       
         }
  client.stop();
  if (fail_sent>1)  
     {
      delay(60000);
      ESP.restart();
     }
  
#ifndef NDEBUG  
  Serial.println(F("disconnecting."));
  Serial.println(F("closing connection"));
#endif

 if (res_reason!=REASON_EXT_SYS_RST)
    for (int i=0; i<12; i++)               // 5 min BEEP-BEEP
        {
         blink_mode = 0B00001111; //Мигание по 0.5 сек
         delay(5000);
         blink_mode = 0B00000001; //Короткая вспышка раз в секунду
         delay(5000);
         blink_mode = 0B00000101; //Две короткие вспышки раз в секунду
         delay(5000);
         blink_mode = 0B00010101; //Три короткие вспышки раз в секунду
         delay(5000);
         blink_mode = 0B01010101;  //Частые короткие вспышки (4 раза в секунду)
         delay(5000); 
        }
 ESP.deepSleep(0);
}
